/* eslint-disable no-magic-numbers */
import { Coordinate } from 'ol/coordinate';

export default function getCentroid(coords: Array<Coordinate>): Coordinate {
  let area = 0;
  let centroidX = 0;
  let centroidY = 0;
  const numPoints = coords.length;

  for (let i = 0; i < numPoints; i += 1) {
    const x1 = coords[i][0];
    const y1 = coords[i][1];
    const x2 = coords[(i + 1) % numPoints][0];
    const y2 = coords[(i + 1) % numPoints][1];
    const crossProduct = x1 * y2 - x2 * y1;
    area += crossProduct;
    centroidX += (x1 + x2) * crossProduct;
    centroidY += (y1 + y2) * crossProduct;
  }

  area /= 2;

  centroidX /= 6 * area;
  centroidY /= 6 * area;

  return [centroidX, centroidY];
}
