/* eslint-disable no-magic-numbers */
import { UsePointToProjectionResult } from '@/utils/map/usePointToProjection';
import getText from './getText';

describe('getText', () => {
  const mockPointToProjection: UsePointToProjectionResult = jest.fn(point => [point.x, point.y]);
  it('should return correct text coordinates and style when text is centered', () => {
    const { textCoords, textStyle } = getText({
      x: 0,
      y: 0,
      height: 100,
      width: 100,
      text: 'Text test',
      fontSize: 12,
      verticalAlign: 'MIDDLE',
      horizontalAlign: 'CENTER',
      pointToProjection: mockPointToProjection,
    });

    expect(textCoords).toEqual([50, 50]);
    expect(textStyle.getText()?.getFont()).toEqual('bold 12px Arial');
  });

  it('should return correct text coordinates and style when text is aligned to bottom', () => {
    const { textCoords, textStyle } = getText({
      x: 20,
      y: 30,
      height: 100,
      width: 100,
      text: 'Text test',
      fontSize: 18,
      verticalAlign: 'BOTTOM',
      horizontalAlign: 'CENTER',
      pointToProjection: mockPointToProjection,
    });

    expect(textCoords).toEqual([70, 121]);

    expect(textStyle.getText()?.getFont()).toEqual('bold 18px Arial');
  });
});
